<?php

namespace App\EventListener;

use Symfony\Component\EventDispatcher\Attribute\AsEventListener;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpKernel\Event\ExceptionEvent;
use Symfony\Component\HttpKernel\KernelEvents;
use Symfony\Component\Security\Core\Exception\BadCredentialsException;
use Symfony\Component\Security\Core\Exception\CredentialsExpiredException;

final class ApiAuthListener
{
    #[AsEventListener(event: KernelEvents::EXCEPTION, priority: 2)]
    public function onKernelException(ExceptionEvent $event): void
    {
        $exception = $event->getThrowable();
        if (!$exception instanceof BadCredentialsException && !$exception instanceof CredentialsExpiredException) {
            return;
        }

        // ... perform some action (e.g. logging)

        if($event->getRequest()->isXmlHttpRequest()) {
            $event->setResponse(new JsonResponse(['error' => $exception->getMessage()], 401));
        }
        // optionally set the custom response

        // or stop propagation (prevents the next exception listeners from being called)
//        $event->stopPropagation();
    }
}
